/*

    Data automatically generated from recode output:

        'recode -lf "CP1252" 2>/dev/null'


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111 USA

*/

#ifndef cp1252_h
#define cp1252_h

#define cet_cs_name_cp1252 "CP1252"

const char *cet_cs_alias_cp1252[] = 
{
	"CP1252", "1252", "ms-ansi", "windows-1252", "WIN-CP1252",
	NULL
};

#define cet_ucs4_ofs_cp1252 128
#define cet_ucs4_cnt_cp1252 128

const int cet_ucs4_map_cp1252[cet_ucs4_cnt_cp1252] =
{
	0x20ac,     -1, 0x201a, 0x0192, 0x201e, 0x2026, 0x2020, 0x2021, 
	0x02c6, 0x2030, 0x0160, 0x2039, 0x0152,     -1, 0x017d,     -1, 
	    -1, 0x2018, 0x2019, 0x201c, 0x201d, 0x2022, 0x2013, 0x2014, 
	0x02dc, 0x2122, 0x0161, 0x203a, 0x0153,     -1, 0x017e, 0x0178, 
	0x00a0, 0x00a1, 0x00a2, 0x00a3, 0x00a4, 0x00a5, 0x00a6, 0x00a7, 
	0x00a8, 0x00a9, 0x00aa, 0x00ab, 0x00ac, 0x00ad, 0x00ae, 0x00af, 
	0x00b0, 0x00b1, 0x00b2, 0x00b3, 0x00b4, 0x00b5, 0x00b6, 0x00b7, 
	0x00b8, 0x00b9, 0x00ba, 0x00bb, 0x00bc, 0x00bd, 0x00be, 0x00bf, 
	0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6, 0x00c7, 
	0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce, 0x00cf, 
	0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7, 
	0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df, 
	0x00e0, 0x00e1, 0x00e2, 0x00e3, 0x00e4, 0x00e5, 0x00e6, 0x00e7, 
	0x00e8, 0x00e9, 0x00ea, 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef, 
	0x00f0, 0x00f1, 0x00f2, 0x00f3, 0x00f4, 0x00f5, 0x00f6, 0x00f7, 
	0x00f8, 0x00f9, 0x00fa, 0x00fb, 0x00fc, 0x00fd, 0x00fe, 0x00ff
};

#define cet_ucs4_to_cp1252_ct 27

const cet_ucs4_link_t cet_ucs4_to_cp1252_links[cet_ucs4_to_cp1252_ct] =
{
	 {0x0152, 0x8c} /* capital ligature oe */,
	 {0x0153, 0x9c} /* small ligature oe */,
	 {0x0160, 0x8a} /* capital letter s with caron */,
	 {0x0161, 0x9a} /* small letter s with caron */,
	 {0x0178, 0x9f} /* capital letter y with diaeresis */,
	 {0x017d, 0x8e} /* capital letter z with caron */,
	 {0x017e, 0x9e} /* small letter z with caron */,
	 {0x0192, 0x83} /* minuscule latine f hameon */,
	 {0x02c6, 0x88} /* modificative accent circonflexe */,
	 {0x02dc, 0x98} /* tilde */,
	 {0x2013, 0x96} /* dash */,
	 {0x2014, 0x97} /* dash */,
	 {0x2018, 0x91} /* single quotation mark */,
	 {0x2019, 0x92} /* single quotation mark */,
	 {0x201a, 0x82} /* low-9 quotation mark */,
	 {0x201c, 0x93} /* double quotation mark */,
	 {0x201d, 0x94} /* double quotation mark */,
	 {0x201e, 0x84} /* low-9 quotation mark */,
	 {0x2020, 0x86} /* dagger */,
	 {0x2021, 0x87} /* dagger */,
	 {0x2022, 0x95} /* puce */,
	 {0x2026, 0x85} /* horizontal ellipsis */,
	 {0x2030, 0x89} /* mille sign */,
	 {0x2039, 0x8b} /* left-pointing angle quotation mark */,
	 {0x203a, 0x9b} /* right-pointing angle quotation mark */,
	 {0x20ac, 0x80} /* euro */,
	 {0x2122, 0x99} /* mark sign */
};

/* Extra table was generated from bestfit1252.txt located at
   ftp.unicode.org:/Public/MAPPINGS/VENDORS/MICSFT/WindowsBestFit/ */
  
const cet_ucs4_link_t cet_ucs4_to_cp1252_extra[] = 
{
	{0x0110, 0xd0} /* latin capital letter d with stroke */,
	{0x0189, 0xd0} /* latin capital letter african d */,
	{0x0191, 0x83} /* latin capital letter f with hook */,
	{0x02c9, 0xaf} /* modifier letter macron */,
	{0x02ca, 0xb4} /* modifier letter acute accent */,
	{0x02da, 0xb0} /* ring above */,
	{0x0301, 0xb4} /* combining acute accent */,
	{0x0304, 0xaf} /* combining macron */,
	{0x0305, 0xaf} /* combining overline */,
	{0x0308, 0xa8} /* combining diaeresis */,
	{0x030a, 0xb0} /* combining ring above */,
	{0x0327, 0xb8} /* combining cedilla */,
	{0x03b2, 0xdf} /* greek small letter beta */,
	{0x03bc, 0xb5} /* greek small letter mu */,
	{0x2024, 0xb7} /* one dot leader */,
	{0x2070, 0xb0} /* superscript zero */,
	{0x20a1, 0xa2} /* colon sign */,
	{0x20a4, 0xa3} /* lira sign */,
	{0x212b, 0xc5} /* angstrom sign */,
	{0x2205, 0xd8} /* empty set */,
	{0x2213, 0xb1} /* minus-or-plus sign */,
	{0x2218, 0xb0} /* ring operator */,
	{0x2219, 0xb7} /* bullet operator */,
	{0x2248, 0x98} /* almost equal to */,
	{0x226a, 0xab} /* much less-than */,
	{0x226b, 0xbb} /* much greater-than */,
	{0x22c5, 0xb7} /* dot operator */,
	{0x2302, 0xa6} /* house */,
	{0x2310, 0xac} /* reversed not sign */,
	{0x2502, 0xa6} /* box drawings light vertical */,
	{0x2524, 0xa6} /* box drawings light vertical and left */,
	{0x2551, 0xa6} /* box drawings double vertical */,
	{0x255e, 0xa6} /* box drawings vertical single and right double */,
	{0x255f, 0xa6} /* box drawings vertical double and right single */,
	{0x2560, 0xa6} /* box drawings double vertical and right */,
	{0x2561, 0xa6} /* box drawings vertical single and left double */,
	{0x2562, 0xa6} /* box drawings vertical double and left single */,
	{0x2563, 0xa6} /* box drawings double vertical and left */,
	{0x2580, 0xaf} /* upper half block */,
	{0x2588, 0xa6} /* full block */,
	{0x258c, 0xa6} /* left half block */,
	{0x2590, 0xa6} /* right half block */,
	{0x2591, 0xa6} /* light shade */,
	{0x2592, 0xa6} /* medium shade */,
	{0x2593, 0xa6} /* dark shade */,
	{0x25a0, 0xa6} /* black square */,
	{0x263c, 0xa4} /* white sun with rays */,
	{0x300a, 0xab} /* left double angle bracket */,
	{0x300b, 0xbb} /* right double angle bracket */,
	{0x30fb, 0xb7} /* katakana middle dot */
};

#define cet_ucs4_to_cp1252_extra_ct sizeof(cet_ucs4_to_cp1252_extra) / sizeof(cet_ucs4_to_cp1252_extra[0])

cet_cs_vec_t cet_cs_vec_cp1252 =	/* defined in cet.h */
{	
	cet_cs_name_cp1252,		/* name of character set	*/
	cet_cs_alias_cp1252,		/* alias table			*/

	NULL,				/* ... to UCS-4 converter (multi-byte) */
	NULL,				/* UCS-4 to ... converter (multi-byte) */

	cet_ucs4_map_cp1252,		/* char to UCS-4 value table	*/
	cet_ucs4_ofs_cp1252,		/* first non standard character	*/
	cet_ucs4_cnt_cp1252,		/* number of values in table	*/

	cet_ucs4_to_cp1252_links,	/* UCS-4 to char links		*/
	cet_ucs4_to_cp1252_ct,		/* number of links		*/

	cet_ucs4_to_cp1252_extra,	/* hand made UCS-4 links	*/
	cet_ucs4_to_cp1252_extra_ct,	/* number of extra links	*/

	NULL	/* for internal use */
};


/*
const int cp1252_ucs4_full_map[] =
{
	0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007, 
	0x0008, 0x0009, 0x000a, 0x000b, 0x000c, 0x000d, 0x000e, 0x000f, 
	0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016, 0x0017, 
	0x0018, 0x0019, 0x001a, 0x001b, 0x001c, 0x001d, 0x001e, 0x001f, 
	0x0020, 0x0021, 0x0022, 0x0023, 0x0024, 0x0025, 0x0026, 0x0027, 
	0x0028, 0x0029, 0x002a, 0x002b, 0x002c, 0x002d, 0x002e, 0x002f, 
	0x0030, 0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037, 
	0x0038, 0x0039, 0x003a, 0x003b, 0x003c, 0x003d, 0x003e, 0x003f, 
	0x0040, 0x0041, 0x0042, 0x0043, 0x0044, 0x0045, 0x0046, 0x0047, 
	0x0048, 0x0049, 0x004a, 0x004b, 0x004c, 0x004d, 0x004e, 0x004f, 
	0x0050, 0x0051, 0x0052, 0x0053, 0x0054, 0x0055, 0x0056, 0x0057, 
	0x0058, 0x0059, 0x005a, 0x005b, 0x005c, 0x005d, 0x005e, 0x005f, 
	0x0060, 0x0061, 0x0062, 0x0063, 0x0064, 0x0065, 0x0066, 0x0067, 
	0x0068, 0x0069, 0x006a, 0x006b, 0x006c, 0x006d, 0x006e, 0x006f, 
	0x0070, 0x0071, 0x0072, 0x0073, 0x0074, 0x0075, 0x0076, 0x0077, 
	0x0078, 0x0079, 0x007a, 0x007b, 0x007c, 0x007d, 0x007e, 0x007f, 
	0x20ac,     -1, 0x201a, 0x0192, 0x201e, 0x2026, 0x2020, 0x2021, 
	0x02c6, 0x2030, 0x0160, 0x2039, 0x0152,     -1, 0x017d, 0x017e, 
	    -1, 0x2018, 0x2019, 0x201c, 0x201d, 0x2022, 0x2013, 0x2014, 
	0x02dc, 0x2122, 0x0161, 0x203a, 0x0153,     -1,     -1, 0x0178, 
	0x00a0, 0x00a1, 0x00a2, 0x00a3, 0x00a4, 0x00a5, 0x00a6, 0x00a7, 
	0x00a8, 0x00a9, 0x00aa, 0x00ab, 0x00ac, 0x00ad, 0x00ae, 0x00af, 
	0x00b0, 0x00b1, 0x00b2, 0x00b3, 0x00b4, 0x00b5, 0x00b6, 0x00b7, 
	0x00b8, 0x00b9, 0x00ba, 0x00bb, 0x00bc, 0x00bd, 0x00be, 0x00bf, 
	0x00c0, 0x00c1, 0x00c2, 0x00c3, 0x00c4, 0x00c5, 0x00c6, 0x00c7, 
	0x00c8, 0x00c9, 0x00ca, 0x00cb, 0x00cc, 0x00cd, 0x00ce, 0x00cf, 
	0x00d0, 0x00d1, 0x00d2, 0x00d3, 0x00d4, 0x00d5, 0x00d6, 0x00d7, 
	0x00d8, 0x00d9, 0x00da, 0x00db, 0x00dc, 0x00dd, 0x00de, 0x00df, 
	0x00e0, 0x00e1, 0x00e2, 0x00e3, 0x00e4, 0x00e5, 0x00e6, 0x00e7, 
	0x00e8, 0x00e9, 0x00ea, 0x00eb, 0x00ec, 0x00ed, 0x00ee, 0x00ef, 
	0x00f0, 0x00f1, 0x00f2, 0x00f3, 0x00f4, 0x00f5, 0x00f6, 0x00f7, 
	0x00f8, 0x00f9, 0x00fa, 0x00fb, 0x00fc, 0x00fd, 0x00fe, 0x00ff
};
*/

#endif
